﻿// ----------------------------------------------------------------------------------
//
// Copyright Microsoft Corporation
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ----------------------------------------------------------------------------------

namespace Microsoft.Azure.Commands.Resources.Models.ActiveDirectory
{
    internal static class ParameterSet
    {
        public const string Mail = "MailParameterSet";

        public const string UPN = "UPNParameterSet";

        public const string SPN = "SPNParameterSet";

        public const string SearchString = "SearchStringParameterSet";

        public const string ObjectId = "ObjectIdParameterSet";

        public const string Scope = "ScopeParameterSet";

        public const string ScopeWithMail = "ScopeWithMailParameterSet";

        public const string ScopeWithUPN = "ScopeWithUPNParameterSet";

        public const string ScopeWithSPN = "ScopeWithSPNParameterSet";

        public const string ScopeWithObjectId = "ScopeWithObjectIdParameterSet";

        public const string ResourceGroup = "ResourceGroupParameterSet";

        public const string ResourceGroupWithMail = "ResourceGroupWithMailParameterSet";

        public const string ResourceGroupWithUPN = "ResourceGroupWithUPNParameterSet";

        public const string ResourceGroupWithSPN = "ResourceGroupWithSPNParameterSet";

        public const string ResourceGroupWithObjectId = "ResourceGroupWithObjectIdParameterSet";

        public const string Resource = "ResourceParameterSet";

        public const string ResourceWithMail = "ResourceWithMailParameterSet";

        public const string ResourceWithUPN = "ResourceWithUPNParameterSet";

        public const string ResourceWithSPN = "ResourceWithSPNParameterSet";

        public const string ResourceWithObjectId = "ResourceWithObjectIdParameterSet";

        public const string ApplicationWithoutCredential = "ApplicationWithoutCredentialParameterSet";

        public const string ApplicationWithPasswordPlain = "ApplicationWithPasswordPlainParameterSet";

        public const string ApplicationWithPasswordCredential = "ApplicationWithPasswordCredentialParameterSet";

        public const string ApplicationWithKeyPlain = "ApplicationWithKeyPlainParameterSet";

        public const string ApplicationWithKeyCredential = "ApplicationWithKeyCredentialParameterSet";

        public const string Empty = "EmptyParameterSet";

        public const string InputFile = "InputFileParameterSet";

        public const string RoleDefinition = "RoleDefinitionParameterSet";
    }
}
